//////////////////////////////////////////////////////////////////////////
//
// DataTypes
//
//////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////
//
// Ieder type variabele heeft zijn eigen hoofd class.
// Deze hoofd classen moeten ook worden geimplementeerd als zijnde gebruikte
// driver classes.
//
// de hoofd class heeft een array van data pointers met als grootte 2
// dit is uiteraard in te stellen!
// iedere driver moet zijn callback meegeven aan de hoofdclass.
//
//////////////////////////////////////////////////////////////////////////

#include <pkgconf/system.h>     /* which packages are enabled/disabled */
#ifdef CYGPKG_KERNEL
# include <pkgconf/kernel.h>
#endif
#ifdef CYGPKG_LIBC
# include <pkgconf/libc.h>
#endif
#ifdef CYGPKG_IO_SERIAL
# include <pkgconf/io_serial.h>
#endif

#ifndef CYGFUN_KERNEL_API_C
# error Kernel API must be enabled to build this example
#endif

#ifndef CYGPKG_LIBC_STDIO
# error C library standard I/O must be enabled to build this example
#endif

#ifndef CYGPKG_IO_SERIAL_HALDIAG
# error I/O HALDIAG pseudo-device driver must be enabled to build this example
#endif

/* INCLUDES */

//#include <stdio.h>                      /* printf */
//#include <string.h>                     /* strlen */
//#include <math.h>
#include <stdlib.h>
#include <cyg/infra/diag.h>             /* diag.print */
#include <cyg/kernel/kapi.h>            /* All the kernel specific stuff */
#include <cyg/io/io.h>                  /* I/O functions */
#include <cyg/hal/hal_arch.h>           /* CYGNUM_HAL_STACK_SIZE_TYPICAL */


#include "DataTypes.h"
#include "Global.h"

//////////////////////////////////////////////////////////////////////////////////
//
// cyg_uint8 class 
//
//////////////////////////////////////////////////////////////////////////////////

ClassInt8::ClassInt8()
{
  ClassInit();
}

///////////////////////////////////////////////////
// 
// All value's are set to zero
//
// Ive planned here a file read to init the values
//
//////////////////////////////////////////////////
void ClassInt8::ClassInit()
{
  cyg_uint32 i;
  D_4(diag_printf("Lock mutex\n"));
  D_4(diag_printf("Mutex address: %08X\n", &MyMutex));
  cyg_mutex_lock(&MyMutex);

  D_4(diag_printf("mutex locked, do whatever you want...\n"));

  D_4(diag_printf("Try to unlock mutex\n"));

  cyg_mutex_unlock(&MyMutex);

  D_4(diag_printf("Mutex Unlocked \n"));
}

///////////////////////////////////////////////////
// 
// Read the current (latest written) value
//
///////////////////////////////////////////////////

Cyg_ErrNo ClassInt8::GetValue(cyg_uint8 *HulpVar)
{
  cyg_mutex_lock(&MyMutex);
  *HulpVar=Value[ThisIndex].Value;
  cyg_mutex_unlock(&MyMutex);
  return 0;
}

//////////////////////////////////////////////////////////
//
// specified value 
//
// DANGER, DANGER, (HIGH VOLTAGE...... ;-)
// this is a floating array. the last added value doesnt have the index 0!! but LastIndex !!!!!!
//
//////////////////////////////////////////////////////////

// Cyg_ErrNo ClassInt8::GetValue(cyg_uint8 *HulpVar, cyg_uint32 Indexje)
// {
//   cyg_mutex_lock(&MyMutex);
//   *HulpVar=Value[Indexje].Value;
//   cyg_mutex_unlock(&MyMutex);
//   return 0;
// }

//////////////////////////////////////////////////////////////
//
// display value()
// This is a test function
// So don't use it!
//
/////////////////////////////////////////////////////////////
Cyg_ErrNo ClassInt8::displayValue()
{
cyg_uint32 Indexje;

 for (Indexje=0; Indexje < DATA_BUFFERSIZE; Indexje++)
   {
     D_4(diag_printf("val. %d\n",Value[Indexje].Value));
   }
 return 0;
}
//////////////////////////////////////////////////////////
//
// add a new value at a specific place
//
// DANGER, DANGER, (HIGH VOLTAGE...... ;-)
// this is a floating array. the last added value doesnt have the index 0!! but LastIndex !!!!!!
// This function should not be used!
//
//////////////////////////////////////////////////////////

// Cyg_ErrNo ClassInt8::AddValue(cyg_uint8 HulpVar, cyg_uint32 Indexje)
// {
//   D_4(diag_printf("AddValue Hulpvar, Indexje  entered. Attempting to unlock mutex \n"));

//   cyg_mutex_lock(&MyMutex);
//   D_4(diag_printf("AddValue Mutex locked \n"));

//   Value[Indexje].Value=HulpVar;

//   D_4(diag_printf("Add Value try to unlock mutex \n"));
//   cyg_mutex_unlock(&MyMutex);

//   D_4(diag_printf("Add Value Mutex unlocked again \n"));

//   return 0;
// }

// add a new value
Cyg_ErrNo ClassInt8::AddValue(cyg_uint8 HulpVar)
{
  cyg_mutex_lock(&MyMutex);
  Value[ThisIndex].Value=HulpVar;
  ThisIndex++;
  cyg_mutex_unlock(&MyMutex);

  ////////////////////////////////////////////////////////////
  // 
  // 'someone' added a value
  //
  // RT:
  // reserved to define a callback to the upper drivers....
  // and monitors ofcourse ......
  //
  ////////////////////////////////////////////////////////////

  return ENOERR;
}



ClassInt8::~ClassInt8()
{

}

//////////////////////////////////////////////////////////////////////////////////
//
// Implementation of the IEC shell
//
// cyg_uint8 IEC class with cyg_uint8 inside
//
//////////////////////////////////////////////////////////////////////////////////

ClassInt8_IEC::ClassInt8_IEC()
{

}

ClassInt8_IEC::ClassInt8_IEC(ClassInt8 *uint8Class)
{
  ThisVarClass=uint8Class;
}

ClassInt8_IEC::ClassInt8_IEC(ClassInt8 *uint8Class, CYG_BYTE *IOA)
{
  ThisIOA[0]=10;
  ThisVarClass=uint8Class;
}

ClassInt8_IEC::ClassInt8_IEC(ClassInt8 *uint8Class, cyg_uint32 IOA)
{
  ThisIOA[0]=10;
  ThisVarClass=uint8Class;
}

Cyg_ErrNo ClassInt8_IEC::GetValue(cyg_uint8 *HulpVar)
{
  return ThisVarClass->GetValue(HulpVar);
}

Cyg_ErrNo ClassInt8_IEC::GetValue(cyg_uint8 *HulpVar, cyg_uint32 Indexje)
{
 //  return ThisVarClass->GetValue(HulpVar, Indexje);
  return 0;
}

Cyg_ErrNo ClassInt8_IEC::AddValue(cyg_uint8 HulpVar)
{
  return ThisVarClass->AddValue(HulpVar);
}

//////////////////////////////////////////////////////////////
//
// ReadMe()
// This is a test function
// So don't use it!
//
/////////////////////////////////////////////////////////////
Cyg_ErrNo ClassInt8_IEC::ReadMe()
{
  ThisVarClass->displayValue();
  return ENOERR;
}


ClassInt8_IEC::~ClassInt8_IEC()
{

}





//////////////////////////////////////////////////////////////////////////////////
//
// Implementation of the monitor shell class
//
// cyg_uint8 Monitor class with cyg_uint8 inside
//
//////////////////////////////////////////////////////////////////////////////////

ClassInt8_MON::ClassInt8_MON()
{

}

ClassInt8_MON::ClassInt8_MON(ClassInt8 *uint8Class)
{
  ThisVarClass=uint8Class;
}


Cyg_ErrNo ClassInt8_MON::GetValue(cyg_uint8 *HulpVar)
{
  return ThisVarClass->GetValue(HulpVar);
}

Cyg_ErrNo ClassInt8_MON::GetValue(cyg_uint8 *HulpVar, cyg_uint32 Indexje)
{
  //  return ThisVarClass->GetValue(HulpVar, Indexje);
  return 0;
}

Cyg_ErrNo ClassInt8_MON::AddValue(cyg_uint8 HulpVar)
{
  return ThisVarClass->AddValue(HulpVar);
}

Cyg_ErrNo ClassInt8_MON::AddValue(cyg_uint8 HulpVar, cyg_uint32 Indexje)
{
  //  return ThisVarClass->AddValue(HulpVar, Indexje);  
  return 0;
}



ClassInt8_MON::~ClassInt8_MON()
{

}


//////////////////////////////////////////////////////////////
//
// FillMe()
// This is only a test function
// So don't use it for real !!!
//
/////////////////////////////////////////////////////////////
Cyg_ErrNo ClassInt8_MON::FillMe()
{
  cyg_uint8 i;
  cyg_uint32 ThisIndex;
  Cyg_ErrNo ThisError;

  D_4(diag_printf("Entering Fill me \n"));
  i=4;
  for (ThisIndex = 0; ThisIndex < DATA_BUFFERSIZE; ThisIndex++)
    {
      D_4(diag_printf("attempt to write: index %d value %d\n",ThisIndex, i));
      //      ThisError = ThisVarClass->AddValue(i,ThisIndex);
      D_4(diag_printf("written index %d value %d\n",ThisIndex, i));

      if (i == 99)
	i=3;
      else
	i++;
    }

  return ENOERR;
}

//////////////////////////////////////////////////////////////
//
// ReadMe()
// This is a test function
// So don't use it!
//
/////////////////////////////////////////////////////////////
Cyg_ErrNo ClassInt8_MON::ReadMe()
{
  ThisVarClass->displayValue();
  return ENOERR;
}

