/***************************************************
 **                                               **
 **     De data klasse                            **
 **                                               **
 **     Hier worden alle var's als struct's       **
 **     gedeclareerd.                             **
 **                                               **
 **                                               **
 **                                               **
 **                                               **
 **                                               **
 ***************************************************/

#if !defined(DATATYPES_HEADERFILEINCLUDED)
#define DATATYPES_HEADERFILEINCLUDED

/* CONFIGURATION CHECKS */

#include <pkgconf/system.h>     /* which packages are enabled/disabled */
#ifdef CYGPKG_KERNEL
# include <pkgconf/kernel.h>
#endif
#ifdef CYGPKG_LIBC
# include <pkgconf/libc.h>
#endif
#ifdef CYGPKG_IO_SERIAL
# include <pkgconf/io_serial.h>
#endif

#ifndef CYGFUN_KERNEL_API_C
# error Kernel API must be enabled to build this example
#endif

#ifndef CYGPKG_LIBC_STDIO
# error C library standard I/O must be enabled to build this example
#endif

#ifndef CYGPKG_IO_SERIAL_HALDIAG
# error I/O HALDIAG pseudo-device driver must be enabled to build this example
#endif

/* INCLUDES */

#include <cyg/infra/diag.h>             /* diag.print */
#include <cyg/kernel/kapi.h>            /* All the kernel specific stuff */
#include <cyg/io/io.h>                  /* I/O functions */
#include <cyg/hal/hal_arch.h>           /* CYGNUM_HAL_STACK_SIZE_TYPICAL */
#include <cyg/io/serialio.h>
#include <cyg/hal/hal_intr.h>

#include "Global.h"

// temp. struct timestamp..
typedef struct TimeStamps{
  cyg_uint32 SerialTime;
  cyg_uint16 MilliSeconds;
}TimeStamp;

// var.
typedef struct Int8Vars{
  cyg_uint8 Value;
  TimeStamp TimeStampVal;
}Int8Var;


class ClassInt8
{
 public:
  // default constructor
  ClassInt8();

  cyg_uint8 GetSize();
  
  Cyg_ErrNo GetValue(cyg_uint8 *HulpVar);
  //  Cyg_ErrNo GetValue(cyg_uint8 *HulpVar, cyg_uint32 Indexje);
  Cyg_ErrNo GetlastValue(cyg_uint8 *HulpVar);
  //  Cyg_ErrNo AddValue(cyg_uint8 HulpVar, cyg_uint32 Indexje);
  Cyg_ErrNo AddValue(cyg_uint8 HulpVar);

  Cyg_ErrNo displayValue();

  virtual ~ClassInt8();

 private:

  void ClassInit();

  Int8Var Value[DATA_BUFFERSIZE];   // buffersize is defined in Globals.h
  cyg_uint8 SizeOff;
  cyg_uint32 ThisIndex;

  // This is what its all about...

  cyg_mutex_t MyMutex;
  //  cyg_mutex_t MyMutex, dummy, tumtummy, cumcummy;
};


///////////////////////////////////////////////////////////////
//
// implementatie datatypen IECdriver
//
///////////////////////////////////////////////////////////////

class ClassInt8_IEC
{
 public:
  ClassInt8_IEC();
  ClassInt8_IEC(ClassInt8 *uint8Class);
  ClassInt8_IEC(ClassInt8 *uint8Class, CYG_BYTE *IOA);
  ClassInt8_IEC(ClassInt8 *uint8Class, cyg_uint32 IOA);


  Cyg_ErrNo GetValue(cyg_uint8 *HulpVar);
  Cyg_ErrNo GetValue(cyg_uint8 *HulpVar, cyg_uint32 Indexje);
  Cyg_ErrNo AddValue(cyg_uint8 HulpVar);

  Cyg_ErrNo ReadMe();

  virtual ~ClassInt8_IEC();

 private:

  CYG_BYTE ThisIOA[IOA_LEN];
  ClassInt8 *ThisVarClass;
  cyg_uint32 LastTransmitted;
  CYG_BYTE ThisType;
};


///////////////////////////////////////////////////////////////
//
// implementatie datatypen Monitor driver
//
///////////////////////////////////////////////////////////////

class ClassInt8_MON
{
 public:
  ClassInt8_MON();
  ClassInt8_MON(ClassInt8 *uint8Class);

  Cyg_ErrNo GetValue(cyg_uint8 *HulpVar);
  Cyg_ErrNo GetValue(cyg_uint8 *HulpVar, cyg_uint32 Indexje);
  Cyg_ErrNo AddValue(cyg_uint8 HulpVar);
  Cyg_ErrNo AddValue(cyg_uint8 HulpVar, cyg_uint32 Indexje);

  Cyg_ErrNo FillMe();
  Cyg_ErrNo ReadMe();

  virtual ~ClassInt8_MON();

 private:
  ClassInt8 *ThisVarClass;

};

#endif //!defined(DATATYPES_HEADERFILEINCLUDED)
