/************************************************************
 ** 
 ** GLOBAL HEADER 
 **
 ** All global defines will be made here
 ** 
 ** The first chapter is from Ronald
 **
 **
 ** Hoe werkt dit?
 **
 ** Eerst moet het OS gedefinieerd worden.
 ** daarna het niveau van verbose
 ** 
 ** MA_PRINTCOMMAND is een macro die het commando uitvoerd
 **
 ** Het gekozen OS defenieerd de nieuw toe te voegen classe
 ** waarin je gewoon een "iets" in kan proppen.
 **
 ************************************************************/

 

/************************************************************
 **
 ** Chapter one.... 
 **
 ************************************************************/


 
/************************************************************
 **
 ** Test on HER / RE defenitions
 **
 ************************************************************/

#ifndef		GLOBALMODEM_DEFINITIONS
#define		GLOBALMODEM_DEFINITIONS 1

/************************************************************
 ** Define your OS
 ** 
 ** CAUTION:
 ** THIS IS NOT ONLY USED FOR DEBUG INFO!!!
 ** So it is important to choose this right .........           or left ;-)
 **
 ************************************************************/
#define		WINDOWS 0
#define		LINUX	0
#define		ECOS	1
#define		TEST	0

/************************************************************
 ** Verbose level: 
 ** 0 no messages
 ** 1 only exceptions
 ** 2 extra info
 ** 3 full info
 ** 4 X-tra info
 **
 ************************************************************/

#define		VERBOSE_LEVEL	4
#define		C_FILE			1
#define		ROW_NO			1

/************************************************************
 ** 
 ** VARIABLE DEFINITIONS / declarations
 **
 ************************************************************/

#define		ARRAYSIZE 10
#define         NULLPT    ((void *)0)

// single acknowledge is used
#define SC_ACK_USED 1

#define MAX_FRAME_LEN 122

#define OK TRUE
#define NOK FALSE

#define VARSQ 2
#define CAA_LEN 2
#define IOA_LEN 2

#define CAA_NUMBER 100

#define DATA_BUFFERSIZE 10

/************************************************************/

/************************************************************
 ** 
 ** define debug macro's
 ** 
 ** define all 4 levels as no comment
 ** This will be preprocessed as the C's comment
 ** 
 ************************************************************/
#define		D_1(debuginfo) 
#define		D_2(debuginfo) 
#define		D_3(debuginfo) 
#define		D_4(debuginfo) 

/*
#ifdef C_FILE
	#define MA_PRINTCFILE
#else
	#define MA_PRINTCFILE
#endif

#ifdef ROW_NO
	#define MA_PRINTROWNO
#else
	#define MA_PRINTROWNO
#endif
*/


/************************************************************
 **
 ** debug print macro inclusion
 **
 ************************************************************/

#ifndef MYDEFINITIONS
#define MYDEFINITIONS 1
	#ifdef ECOS
		#define		MA_PRINTCOMMAND(debuginfo)	\
			 diag_printf("%s:%d ",__FILE__,__LINE__);	\
			 (debuginfo)
	#elif WINDOWS									             
		#define		MA_PRINTCOMMAND(debuginfo)	\
			 fprintf(stdout,"%s:%d ",__FILE__,__LINE__);	\
			 fprintf(stdout,(debuginfo))
	#elif LINUX
		#define		MA_PRINTCOMMAND(debuginfo)	\
			 fprintf(stdout,"%s:%d ",__FILE__,__LINE__);	\
			 fprintf(stdout,(debuginfo))
	#elif TEST
		#define		MA_PRINTCOMMAND(debuginfo) printf((debuginfo))
	#endif
#endif // #define MYDEFINITIONS 1

/************************************************************
 **
 ** Redefine the debug macros
 **
 ************************************************************/

	#if VERBOSE_LEVEL>0
                #undef	D_1
		#define D_1(debuginfo) MA_PRINTCOMMAND(debuginfo)
	#endif	
	#if VERBOSE_LEVEL>1
                #undef	D_2
		#define D_2(debuginfo) MA_PRINTCOMMAND(debuginfo)
	#endif	
	#if VERBOSE_LEVEL > 2
                #undef	D_3
		#define D_3(debuginfo) MA_PRINTCOMMAND(debuginfo)
	#endif	
	#if VERBOSE_LEVEL > 3
                #undef	D_4
		#define D_4(debuginfo) MA_PRINTCOMMAND(debuginfo)
	#endif	


typedef struct DataFrames
{
  CYG_BYTE *data;
  cyg_uint16 length;
}DataFrame;

#endif // #define		GLOBALMODEM_DEFINITIONS 1

