/* 
 * Written 1999-03-19 by Jonathan Larmour, Cygnus Solutions
 * This file is in the public domain and may be used for any purpose
 */

/* CONFIGURATION CHECKS */

#include <pkgconf/system.h>     /* which packages are enabled/disabled */
#ifdef CYGPKG_KERNEL
# include <pkgconf/kernel.h>
#endif
#ifdef CYGPKG_LIBC
# include <pkgconf/libc.h>
#endif
#ifdef CYGPKG_IO_SERIAL
# include <pkgconf/io_serial.h>
#endif

#ifndef CYGFUN_KERNEL_API_C
# error Kernel API must be enabled to build this example
#endif

#ifndef CYGPKG_LIBC_STDIO
# error C library standard I/O must be enabled to build this example
#endif

#ifndef CYGPKG_IO_SERIAL_HALDIAG
# error I/O HALDIAG pseudo-device driver must be enabled to build this example
#endif

/* INCLUDES */

#include <cyg/infra/diag.h>             /* diag.print */
#include <cyg/kernel/kapi.h>            /* All the kernel specific stuff */
#include <cyg/io/io.h>                  /* I/O functions */
#include <cyg/hal/hal_arch.h>           /* CYGNUM_HAL_STACK_SIZE_TYPICAL */
#include <cyg/io/serialio.h>
#include <cyg/hal/hal_intr.h>

#include "Global.h"
#include "DataTypes.h"

/* DEFINES */


// #define NTHREADS 2
// #define STACKSIZE ( CYGNUM_HAL_STACK_SIZE_TYPICAL + 4096 )
// #define DEVICENAME "/dev/ser0"


#ifdef __cplusplus
extern "C" {
#endif

void cyg_user_start(void)
{
  cyg_uint32 i;

  cyg_uint8 HulpInt;

  // construct the class
  // in the constructor an init function is being called.

  ClassInt8 ThisClassje;

  // You will never see this diag comment without defining a dummy mutex in ClassInt8..

  D_4(diag_printf("This Classje defined\n"));

  ClassInt8_IEC ThisIECClassje(&ThisClassje, 100);
  ClassInt8_MON ThisMonClass(&ThisClassje);

  D_4(diag_printf("This Classje binded to drivers\n"));

  ThisMonClass.FillMe();
  D_4(diag_printf("This Classje filled .... with joy....\n"));
  ThisMonClass.ReadMe();
  ThisIECClassje.ReadMe();
  D_4(diag_printf("Class filled and readed out \n"));

  ThisIECClassje.GetValue(&HulpInt);
  D_4(diag_printf("val: %d\n", HulpInt));

//   for (i=1; i<DATA_BUFFERSIZE; i++)
//     {
//       ThisIECClassje.GetValue(&HulpInt, (cyg_uint32)i);
//       D_4(diag_printf("val: %d\n", HulpInt));
//     }

  D_1(diag_printf("Starting Main, define IECdriver \n"));

  D_1(diag_printf("Initiating IECdriver \n"));

//  IECdriver MyIECdriver;

  //  IECdriver MyIECdrivertje(DataBase1);

}
#ifdef __cplusplus
  }
#endif



